diff -uNr djbdns-1.05/socket_recv6.c djbdns-1.05-new/socket_recv6.c
--- djbdns-1.05/socket_recv6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_recv6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,42 @@
+#include <sys/param.h>
+#include "sockaddr_in6.h"
+#include "byte.h"
+#include "socket.h"
+#include "ip6.h"
+#include "haveip6.h"
+#include "error.h"
+
+int socket_recv6(int s,char *buf,unsigned int len,char ip[16],uint16 *port,uint32 *scope_id)
+{
+#ifdef LIBC_HAS_IP6
+  struct sockaddr_in6 sa;
+#else
+  struct sockaddr_in sa;
+#endif
+  unsigned int dummy = sizeof sa;
+  int r;
+
+  byte_zero(&sa,dummy);
+  r = recvfrom(s,buf,len,0,(struct sockaddr *) &sa,&dummy);
+  if (r == -1) return -1;
+
+#ifdef LIBC_HAS_IP6
+  if (noipv6) {
+    struct sockaddr_in *sa4=(struct sockaddr_in *)&sa;
+    byte_copy(ip,12,V4mappedprefix);
+    byte_copy(ip+12,4,(char *) &sa4->sin_addr);
+    uint16_unpack_big((char *) &sa4->sin_port,port);
+    return r;
+  }
+  byte_copy(ip,16,(char *) &sa.sin6_addr);
+  uint16_unpack_big((char *) &sa.sin6_port,port);
+  if (scope_id) *scope_id=sa.sin6_scope_id;
+#else
+  byte_copy(ip,12,(char *)V4mappedprefix);
+  byte_copy(ip+12,4,(char *) &sa.sin_addr);
+  uint16_unpack_big((char *) &sa.sin_port,port);
+  if (scope_id) *scope_id=0;
+#endif
+
+  return r;
+}
diff -uNr djbdns-1.05/socket_send6.c djbdns-1.05-new/socket_send6.c
--- djbdns-1.05/socket_send6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_send6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,39 @@
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include "byte.h"
+#include "socket.h"
+#include "ip6.h"
+#include "haveip6.h"
+#include "error.h"
+
+int socket_send6(int s,const char *buf,unsigned int len,const char ip[16],uint16 port,uint32 scope_id)
+{
+#ifdef LIBC_HAS_IP6
+  struct sockaddr_in6 sa;
+#else
+  struct sockaddr_in sa;
+#endif
+
+  byte_zero(&sa,sizeof sa);
+#ifdef LIBC_HAS_IP6
+  if (noipv6) {
+#endif
+    if (ip6_isv4mapped(ip))
+      return socket_send4(s,buf,len,ip+12,port);
+    if (byte_equal(ip,16,V6loopback))
+      return socket_send4(s,buf,len,ip4loopback,port);
+#ifdef LIBC_HAS_IP6
+    errno=error_proto;
+    return -1;
+  }
+  sa.sin6_family = AF_INET6;
+  uint16_pack_big((char *) &sa.sin6_port,port);
+  byte_copy((char *) &sa.sin6_addr,16,ip);
+  return sendto(s,buf,len,0,(struct sockaddr *) &sa,sizeof sa);
+#else
+  errno=error_proto;
+  return -1;
+#endif
+}
diff -uNr djbdns-1.05/socket_tcp6.c djbdns-1.05-new/socket_tcp6.c
--- djbdns-1.05/socket_tcp6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_tcp6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,38 @@
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <errno.h>
+#include <unistd.h>
+#include "ndelay.h"
+#include "socket.h"
+#include "haveip6.h"
+#include "error.h"
+
+#ifndef EAFNOSUPPORT
+#define EAFNOSUPPORT EINVAL
+#endif
+
+int socket_tcp6(void)
+{
+#ifdef LIBC_HAS_IP6
+  int s;
+
+  if (noipv6) goto compat;
+  s = socket(PF_INET6,SOCK_STREAM,0);
+  if (s == -1) {
+    if (errno == EINVAL || errno == EAFNOSUPPORT) {
+compat:
+      s=socket(AF_INET,SOCK_STREAM,0);
+      noipv6=1;
+      if (s==-1) return -1;
+    } else
+    return -1;
+  }
+  if (ndelay_on(s) == -1) { close(s); return -1; }
+  return s;
+#else
+  return socket_tcp();
+#endif
+}
+
diff -uNr djbdns-1.05/socket_udp6.c djbdns-1.05-new/socket_udp6.c
--- djbdns-1.05/socket_udp6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/socket_udp6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,37 @@
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <errno.h>
+#include <unistd.h>
+#include "ndelay.h"
+#include "socket.h"
+#include "haveip6.h"
+#include "error.h"
+
+#ifndef EAFNOSUPPORT
+#define EAFNOSUPPORT EINVAL
+#endif
+
+int socket_udp6(void)
+{
+#ifdef LIBC_HAS_IP6
+  int s;
+
+  if (noipv6) goto compat;
+  s = socket(PF_INET6,SOCK_DGRAM,0);
+  if (s == -1) {
+    if (errno == EINVAL || errno == EAFNOSUPPORT) {
+compat:
+      s=socket(AF_INET,SOCK_DGRAM,0);
+      noipv6=1;
+      if (s==-1) return -1;
+    } else
+    return -1;
+  }
+  if (ndelay_on(s) == -1) { close(s); return -1; }
+  return s;
+#else
+  return socket_udp();
+#endif
+}
diff -uNr djbdns-1.05/tdlookup.c djbdns-1.05-new/tdlookup.c
--- djbdns-1.05/tdlookup.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/tdlookup.c	2003-09-16 10:09:36.000000000 -0400
@@ -8,6 +8,7 @@
 #include "dns.h"
 #include "seek.h"
 #include "response.h"
+#include "ip6.h"
 
 static int want(const char *owner,const char type[2])
 {
@@ -119,8 +120,9 @@
   char x[20];
   uint16 u16;
   char addr[8][4];
-  int addrnum;
-  uint32 addrttl;
+  char addr6[8][16];
+  int addrnum,addr6num;
+  uint32 addrttl,addr6ttl;
   int i;
 
   anpos = response_len;
@@ -152,8 +154,8 @@
   wild = q;
 
   for (;;) {
-    addrnum = 0;
-    addrttl = 0;
+    addrnum = addr6num = 0;
+    addrttl = addr6ttl = 0;
     cdb_findstart(&c);
     while (r = find(wild,wild != q)) {
       if (r == -1) return 0;
@@ -171,6 +173,17 @@
 	if (addrnum < 1000000) ++addrnum;
 	continue;
       }
+      if (byte_equal(type,2,DNS_T_AAAA) && (dlen - dpos == 16)) {
+	addr6ttl = ttl;
+	i = dns_random(addr6num + 1);
+	if (i < 8) {
+	  if ((i < addr6num) && (addr6num < 8))
+	    byte_copy(addr6[addr6num],16,addr6[i]);
+	  byte_copy(addr6[i],16,data + dpos);
+	}
+	if (addr6num < 1000000) ++addr6num;
+	continue;
+      }
       if (!response_rstart(q,type,ttl)) return 0;
       if (byte_equal(type,2,DNS_T_NS) || byte_equal(type,2,DNS_T_CNAME) || byte_equal(type,2,DNS_T_PTR)) {
 	if (!doname()) return 0;
@@ -195,6 +208,12 @@
 	if (!response_addbytes(addr[i],4)) return 0;
 	response_rfinish(RESPONSE_ANSWER);
       }
+    for (i = 0;i < addr6num;++i)
+      if (i < 8) {
+	if (!response_rstart(q,DNS_T_AAAA,addr6ttl)) return 0;
+	if (!response_addbytes(addr6[i],16)) return 0;
+	response_rfinish(RESPONSE_ANSWER);
+      }
 
     if (flagfound) break;
     if (wild == control) break;
@@ -259,6 +278,11 @@
 	    if (!dobytes(4)) return 0;
             response_rfinish(RESPONSE_ADDITIONAL);
 	  }
+	  else if (byte_equal(type,2,DNS_T_AAAA)) {
+            if (!response_rstart(d1,DNS_T_AAAA,ttl)) return 0;
+	    if (!dobytes(16)) return 0;
+            response_rfinish(RESPONSE_ADDITIONAL);
+	  }
         }
       }
     }
@@ -278,7 +302,7 @@
   return 1;
 }
 
-int respond(char *q,char qtype[2],char ip[4])
+int respond(char *q,char qtype[2],char ip[16])
 {
   int fd;
   int r;
@@ -292,15 +316,17 @@
   byte_zero(clientloc,2);
   key[0] = 0;
   key[1] = '%';
-  byte_copy(key + 2,4,ip);
-  r = cdb_find(&c,key,6);
-  if (!r) r = cdb_find(&c,key,5);
-  if (!r) r = cdb_find(&c,key,4);
-  if (!r) r = cdb_find(&c,key,3);
-  if (!r) r = cdb_find(&c,key,2);
-  if (r == -1) return 0;
-  if (r && (cdb_datalen(&c) == 2))
-    if (cdb_read(&c,clientloc,2,cdb_datapos(&c)) == -1) return 0;
+  if (byte_equal(ip,12,V4mappedprefix)) {
+    byte_copy(key + 2,4,ip+12);
+    r = cdb_find(&c,key,6);
+    if (!r) r = cdb_find(&c,key,5);
+    if (!r) r = cdb_find(&c,key,4);
+    if (!r) r = cdb_find(&c,key,3);
+    if (!r) r = cdb_find(&c,key,2);
+    if (r == -1) return 0;
+    if (r && (cdb_datalen(&c) == 2))
+      if (cdb_read(&c,clientloc,2,cdb_datapos(&c)) == -1) return 0;
+  }
 
   r = doit(q,qtype);
 
diff -uNr djbdns-1.05/tinydns-conf.c djbdns-1.05-new/tinydns-conf.c
--- djbdns-1.05/tinydns-conf.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/tinydns-conf.c	2003-09-16 10:09:36.000000000 -0400
@@ -82,6 +82,18 @@
   finish();
   perm(0755);
 
+  start("root/add-host6");
+  outs("#!/bin/sh\nexec ");
+  outs(auto_home); outs("/bin/tinydns-edit data data.new add host6 ${1+\"$@\"}\n");
+  finish();
+  perm(0755);
+
+  start("root/add-alias6");
+  outs("#!/bin/sh\nexec ");
+  outs(auto_home); outs("/bin/tinydns-edit data data.new add alias6 ${1+\"$@\"}\n");
+  finish();
+  perm(0755);
+
   start("root/add-mx");
   outs("#!/bin/sh\nexec ");
   outs(auto_home); outs("/bin/tinydns-edit data data.new add mx ${1+\"$@\"}\n");
diff -uNr djbdns-1.05/tinydns-data.c djbdns-1.05-new/tinydns-data.c
--- djbdns-1.05/tinydns-data.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/tinydns-data.c	2003-09-16 10:09:36.000000000 -0400
@@ -8,6 +8,7 @@
 #include "byte.h"
 #include "fmt.h"
 #include "ip4.h"
+#include "ip6.h"
 #include "exit.h"
 #include "case.h"
 #include "scan.h"
@@ -172,6 +173,7 @@
 static char *d1;
 static char *d2;
 char dptr[DNS_NAME4_DOMAIN];
+char d6ptr[DNS_NAME6_DOMAIN];
 
 char strnum[FMT_ULONG];
 
@@ -193,6 +195,7 @@
   char loc[2];
   unsigned long u;
   char ip[4];
+  char ip6[16];
   char type[2];
   char soa[20];
   char buf[4];
@@ -339,6 +342,28 @@
 	}
 	break;
 
+      case '6': case '3':
+	if (!dns_domain_fromdot(&d1,f[0].s,f[0].len)) nomem();
+	if (!stralloc_0(&f[2])) nomem();
+	if (!scan_ulong(f[2].s,&ttl)) ttl = TTL_POSITIVE;
+	ttdparse(&f[3],ttd);
+	locparse(&f[4],loc);
+
+	if (!stralloc_0(&f[1])) nomem();
+	if (ip6_scan_flat(f[1].s,ip6)) {
+	  rr_start(DNS_T_AAAA,ttl,ttd,loc);
+	  rr_add(ip6,16);
+	  rr_finish(d1);
+
+	  if (line.s[0] == '6') {
+	    dns_name6_domain(d6ptr,ip6);
+	    rr_start(DNS_T_PTR,ttl,ttd,loc);
+	    rr_addname(d1);
+	    rr_finish(d6ptr);
+	  }
+	}
+	break;
+
       case '@':
 	if (!dns_domain_fromdot(&d1,f[0].s,f[0].len)) nomem();
 	if (!stralloc_0(&f[4])) nomem();
diff -uNr djbdns-1.05/tinydns-edit.c djbdns-1.05-new/tinydns-edit.c
--- djbdns-1.05/tinydns-edit.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/tinydns-edit.c	2003-09-16 10:09:36.000000000 -0400
@@ -13,6 +13,7 @@
 #include "str.h"
 #include "fmt.h"
 #include "ip4.h"
+#include "ip6.h"
 #include "dns.h"
 
 #define FATAL "tinydns-edit: fatal: "
@@ -25,7 +26,8 @@
 
 void die_usage()
 {
-  strerr_die1x(100,"tinydns-edit: usage: tinydns-edit data data.new add [ns|childns|host|alias|mx] domain a.b.c.d");
+  strerr_die1x(100,"tinydns-edit: usage: tinydns-edit data data.new add [ns|childns|host|alias|mx] domain a.b.c.d\n"
+                   "tinydns-edit: usage: tinydns-edit data data.new add [host6|alias6] domain a:b:c:d:e:f:g:h");
 }
 void nomem()
 {
@@ -43,6 +45,7 @@
 char mode;
 static char *target;
 char targetip[4];
+char targetip6[16];
 
 int fd;
 buffer b;
@@ -61,7 +64,9 @@
 static char *d1;
 static char *d2;
 char ip[4];
+char ip6[16];
 char ipstr[IP4_FMT];
+char ip6str[IP6_FMT];
 char strnum[FMT_ULONG];
 
 static char *names[26];
@@ -96,7 +101,9 @@
   if (str_equal(*argv,"ns")) mode = '.';
   else if (str_equal(*argv,"childns")) mode = '&';
   else if (str_equal(*argv,"host")) mode = '=';
+  else if (str_equal(*argv,"host6")) mode = '6';
   else if (str_equal(*argv,"alias")) mode = '+';
+  else if (str_equal(*argv,"alias6")) mode = '3';
   else if (str_equal(*argv,"mx")) mode = '@';
   else die_usage();
 
@@ -104,7 +111,11 @@
   if (!dns_domain_fromdot(&target,*argv,str_len(*argv))) nomem();
 
   if (!*++argv) die_usage();
-  if (!ip4_scan(*argv,targetip)) die_usage();
+  if (mode == '6' || mode == '3') {
+    if (!ip6_scan(*argv,targetip6)) die_usage();
+  } else {
+    if (!ip4_scan(*argv,targetip)) die_usage();
+  }
 
   umask(077);
 
@@ -129,7 +140,7 @@
 	if (!dns_domain_fromdot(&names[i],f[0].s,f[0].len)) nomem();
       }
       break;
-    case '+': case '=':
+    case '+': case '=': case '6': case '3':
       ttl = TTL_POSITIVE;
       break;
     case '@':
@@ -203,6 +214,18 @@
 	}
 	break;
 
+      case '6':
+	if (line.s[0] == '6') {
+	  if (!dns_domain_fromdot(&d1,f[0].s,f[0].len)) nomem();
+	  if (dns_domain_equal(d1,target))
+	    strerr_die2x(100,FATAL,"host name already used");
+	  if (!stralloc_0(&f[1])) nomem();
+	  if (ip6_scan(f[1].s,ip6))
+	    if (byte_equal(ip,16,targetip6))
+	      strerr_die2x(100,FATAL,"IPv6 address already used");
+	}
+	break;
+
       case '@':
 	if (line.s[0] == '@') {
           if (!dns_domain_fromdot(&d1,f[0].s,f[0].len)) nomem();
@@ -228,7 +251,11 @@
   if (!stralloc_copyb(&f[0],&mode,1)) nomem();
   if (!dns_domain_todot_cat(&f[0],target)) nomem();
   if (!stralloc_cats(&f[0],":")) nomem();
-  if (!stralloc_catb(&f[0],ipstr,ip4_fmt(ipstr,targetip))) nomem();
+  if (mode == '6' || mode == '3') {
+    if (!stralloc_catb(&f[0],ip6str,ip6_fmt_flat(ip6str,targetip6))) nomem();
+  } else {
+    if (!stralloc_catb(&f[0],ipstr,ip4_fmt(ipstr,targetip))) nomem();
+  }
   switch(mode) {
     case '.': case '&': case '@':
       for (i = 0;i < 26;++i)
diff -uNr djbdns-1.05/tryip6.c djbdns-1.05-new/tryip6.c
--- djbdns-1.05/tryip6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/tryip6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,8 @@
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+
+main() {
+  struct sockaddr_in6 sa;
+  sa.sin6_family = PF_INET6;
+}
diff -uNr djbdns-1.05/tryn2i.c djbdns-1.05-new/tryn2i.c
--- djbdns-1.05/tryn2i.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/tryn2i.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,8 @@
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <net/if.h>
+
+int main() {
+  static char ifname[IFNAMSIZ];
+  char *tmp=if_indextoname(0,ifname);
+}
diff -uNr djbdns-1.05/trysa6.c djbdns-1.05-new/trysa6.c
--- djbdns-1.05/trysa6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/trysa6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,8 @@
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+
+main() {
+  struct sockaddr_in6 sa;
+  sa.sin6_scope_id = 1;
+}
